"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const promises_1 = require("fs/promises");
const template = __importStar(require("@babel/template"));
const css_1 = require("./css");
const astObject_1 = require("./plugin/astObject");
function handleExpression(path, expression, removeName, mapObj) {
    if (!expression)
        return;
    if (expression.type === "CallExpression") {
        return commonInject(path, expression, {
            name: removeName,
            mapObj,
        });
    }
}
function catomBabelPlugin() {
    let removeName = "css";
    const cssPropertyMap = new Map();
    const mediaQueryMap = new Map();
    const pseudoSelectorMap = new Map();
    const mapObj = {
        cssPropertyMap: cssPropertyMap,
        mediaQueryMap: mediaQueryMap,
        pseudoSelectorMap: pseudoSelectorMap,
    };
    let last;
    return {
        post() {
            const css = (0, css_1.emitCSS)(mapObj);
            if (css == last)
                return;
            last = css;
            if (!this.file)
                return;
            const f = (0, path_1.join)("./", this.__emitFile);
            (0, promises_1.writeFile)(f, css);
        },
        visitor: {
            Program(_, state) {
                if (!state?.opts.emitFile)
                    throw new Error("No emit file provided!");
                this.__emitFile = this.__emitFile || state.opts.emitFile;
            },
            CallExpression(path) {
                return handleExpression(path, path.node, removeName, mapObj);
            },
        },
    };
}
exports.default = catomBabelPlugin;
function commonInject(path, right, options) {
    const callee = right.callee;
    if (callee && callee.type === "Identifier") {
        if (callee.name === options.name) {
            const arg0 = right.arguments[0];
            return injectDependency(path, arg0, options.mapObj);
        }
    }
}
function injectDependency(path, arg0, mapObj) {
    if (arg0.type === "ObjectExpression") {
        let retArray = [];
        (0, astObject_1.parseObjectExpression)(arg0, retArray, null, mapObj);
        path.replaceWith(template.statement.ast(JSON.stringify(retArray.join(" "))));
    }
}
