"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.emitCSS = exports.autoPrefixCSS = void 0;
const postCSS = require("postcss");
const cssTransform_1 = require("./plugin/cssTransform");
Object.defineProperty(exports, "emitCSS", { enumerable: true, get: function () { return cssTransform_1.emitCSS; } });
async function transformCSS(maps, ...plugins) {
    const css = (0, cssTransform_1.emitCSS)(maps);
    const result = await postCSS(...plugins).process(css);
    result.warnings().forEach((warn) => {
        console.warn(warn.toString());
    });
    return result.css;
}
exports.default = transformCSS;
function autoPrefixCSS(maps, ...plugins) {
    return transformCSS(maps, ...plugins.concat(require("autoprefixer")));
}
exports.autoPrefixCSS = autoPrefixCSS;
